<template>
  <div>
    <div class="grid grid-cols-5 gap-3 mb-3">
      <input
        id="phone"
        :value="item.name"
        class="col-span-3 appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
        type="text"
        placeholder="08123456789"
        @input="updateName($event.target.value)"
      />
      <div class="col-span-2 inline-flex flex-shrink-0">
        <Button secondary class="py-2 px-3 rounded-l-lg border-r" :on-click="subsQty">
          <Minus />
        </Button>
        <Cleave
          type="number"
          class="input-number"
          :value="item.qty"
          :options="numberCleaveOption"
          @input="updateQty($event)"
        />
        <Button secondary class="py-2 px-3 rounded-r-lg border-l" :on-click="addQty">
          <Plus />
        </Button>
        <Button ghost class="py-2 px-3" :on-click="deleteItem">
          <Delete />
        </Button>
      </div>
    </div>
  </div>
</template>

<script>
const Plus = () => import('~/components/Icons/plus');
const Minus = () => import('~/components/Icons/minus');
const Delete = () => import('~/components/Icons/delete');
import Cleave from 'vue-cleave-component';

export default {
  components: {
    Plus,
    Minus,
    Cleave,
    Delete,
  },
  props: {
    item: {
      type: Object,
      required: true,
    },
    index: {
      type: Number,
      required: true,
    },
  },
  data() {
    return {
      numberCleaveOption: {
        prefix: '',
        numeral: true,
        numeralPositiveOnly: true,
        noImmediatePrefix: true,
        rawValueTrimPrefix: true,
        numeralDecimalMark: '',
        delimiter: '.',
        numeralIntegerScale: 16,
        numeralDecimalScale: 0,
      },
    };
  },
  computed: {
    itemDetails() {
      return this.$store.state.form.item_details;
    },
  },
  methods: {
    addQty() {
      this.updateQty(parseInt(this.item.qty) + 1, this.index);
    },
    subsQty() {
      this.updateQty(parseInt(this.item.qty) - 1, this.index);
    },
    updateName(value) {
      const itemDetails = JSON.parse(JSON.stringify(this.itemDetails));
      itemDetails[this.index].name = value;
      this.$store.commit('form/SET_ITEM_DETAILS', itemDetails);
    },
    updateQty(value) {
      if (value === null || value < 1) value = 1;
      const itemDetails = JSON.parse(JSON.stringify(this.itemDetails));
      itemDetails[this.index].qty = value;
      this.$store.commit('form/SET_ITEM_DETAILS', itemDetails);
    },
    deleteItem() {
      if (this.itemDetails.length !== 1) {
        this.$store.commit('form/REMOVE_ITEM_DETAILS', this.index);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
input {
  color: $black-alt;
}
.input-number {
  text-align: center;
}
</style>
